<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFareFamilyDescription ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfFareFamilyDescription extends AbstractStructArrayBase
{
    /**
     * The FareFamilyDescription
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \dgsoft\StructType\DgFareFamilyDescription[]
     */
    public $FareFamilyDescription;
    /**
     * Constructor method for ArrayOfFareFamilyDescription
     * @uses DgArrayOfFareFamilyDescription::setFareFamilyDescription()
     * @param \dgsoft\StructType\DgFareFamilyDescription[] $fareFamilyDescription
     */
    public function __construct(array $fareFamilyDescription = array())
    {
        $this
            ->setFareFamilyDescription($fareFamilyDescription);
    }
    /**
     * Get FareFamilyDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \dgsoft\StructType\DgFareFamilyDescription[]|null
     */
    public function getFareFamilyDescription()
    {
        return isset($this->FareFamilyDescription) ? $this->FareFamilyDescription : null;
    }
    /**
     * Set FareFamilyDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgFareFamilyDescription[] $fareFamilyDescription
     * @return \dgsoft\ArrayType\DgArrayOfFareFamilyDescription
     */
    public function setFareFamilyDescription(array $fareFamilyDescription = array())
    {
        foreach ($fareFamilyDescription as $arrayOfFareFamilyDescriptionFareFamilyDescriptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfFareFamilyDescriptionFareFamilyDescriptionItem instanceof \dgsoft\StructType\DgFareFamilyDescription) {
                throw new \InvalidArgumentException(sprintf('The FareFamilyDescription property can only contain items of \dgsoft\StructType\DgFareFamilyDescription, "%s" given', is_object($arrayOfFareFamilyDescriptionFareFamilyDescriptionItem) ? get_class($arrayOfFareFamilyDescriptionFareFamilyDescriptionItem) : gettype($arrayOfFareFamilyDescriptionFareFamilyDescriptionItem)), __LINE__);
            }
        }
        if (is_null($fareFamilyDescription) || (is_array($fareFamilyDescription) && empty($fareFamilyDescription))) {
            unset($this->FareFamilyDescription);
        } else {
            $this->FareFamilyDescription = $fareFamilyDescription;
        }
        return $this;
    }
    /**
     * Add item to FareFamilyDescription value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgFareFamilyDescription $item
     * @return \dgsoft\ArrayType\DgArrayOfFareFamilyDescription
     */
    public function addToFareFamilyDescription(\dgsoft\StructType\DgFareFamilyDescription $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgFareFamilyDescription) {
            throw new \InvalidArgumentException(sprintf('The FareFamilyDescription property can only contain items of \dgsoft\StructType\DgFareFamilyDescription, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FareFamilyDescription[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgFareFamilyDescription|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgFareFamilyDescription|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgFareFamilyDescription|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgFareFamilyDescription|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgFareFamilyDescription|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareFamilyDescription
     */
    public function getAttributeName()
    {
        return 'FareFamilyDescription';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfFareFamilyDescription
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
